// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from puma_motor_msgs:msg/Feedback.idl
// generated code does not contain a copyright notice

#ifndef PUMA_MOTOR_MSGS__MSG__DETAIL__FEEDBACK__BUILDER_HPP_
#define PUMA_MOTOR_MSGS__MSG__DETAIL__FEEDBACK__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "puma_motor_msgs/msg/detail/feedback__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace puma_motor_msgs
{

namespace msg
{

namespace builder
{

class Init_Feedback_setpoint
{
public:
  explicit Init_Feedback_setpoint(::puma_motor_msgs::msg::Feedback & msg)
  : msg_(msg)
  {}
  ::puma_motor_msgs::msg::Feedback setpoint(::puma_motor_msgs::msg::Feedback::_setpoint_type arg)
  {
    msg_.setpoint = std::move(arg);
    return std::move(msg_);
  }

private:
  ::puma_motor_msgs::msg::Feedback msg_;
};

class Init_Feedback_speed
{
public:
  explicit Init_Feedback_speed(::puma_motor_msgs::msg::Feedback & msg)
  : msg_(msg)
  {}
  Init_Feedback_setpoint speed(::puma_motor_msgs::msg::Feedback::_speed_type arg)
  {
    msg_.speed = std::move(arg);
    return Init_Feedback_setpoint(msg_);
  }

private:
  ::puma_motor_msgs::msg::Feedback msg_;
};

class Init_Feedback_travel
{
public:
  explicit Init_Feedback_travel(::puma_motor_msgs::msg::Feedback & msg)
  : msg_(msg)
  {}
  Init_Feedback_speed travel(::puma_motor_msgs::msg::Feedback::_travel_type arg)
  {
    msg_.travel = std::move(arg);
    return Init_Feedback_speed(msg_);
  }

private:
  ::puma_motor_msgs::msg::Feedback msg_;
};

class Init_Feedback_current
{
public:
  explicit Init_Feedback_current(::puma_motor_msgs::msg::Feedback & msg)
  : msg_(msg)
  {}
  Init_Feedback_travel current(::puma_motor_msgs::msg::Feedback::_current_type arg)
  {
    msg_.current = std::move(arg);
    return Init_Feedback_travel(msg_);
  }

private:
  ::puma_motor_msgs::msg::Feedback msg_;
};

class Init_Feedback_duty_cycle
{
public:
  explicit Init_Feedback_duty_cycle(::puma_motor_msgs::msg::Feedback & msg)
  : msg_(msg)
  {}
  Init_Feedback_current duty_cycle(::puma_motor_msgs::msg::Feedback::_duty_cycle_type arg)
  {
    msg_.duty_cycle = std::move(arg);
    return Init_Feedback_current(msg_);
  }

private:
  ::puma_motor_msgs::msg::Feedback msg_;
};

class Init_Feedback_device_name
{
public:
  explicit Init_Feedback_device_name(::puma_motor_msgs::msg::Feedback & msg)
  : msg_(msg)
  {}
  Init_Feedback_duty_cycle device_name(::puma_motor_msgs::msg::Feedback::_device_name_type arg)
  {
    msg_.device_name = std::move(arg);
    return Init_Feedback_duty_cycle(msg_);
  }

private:
  ::puma_motor_msgs::msg::Feedback msg_;
};

class Init_Feedback_device_number
{
public:
  Init_Feedback_device_number()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Feedback_device_name device_number(::puma_motor_msgs::msg::Feedback::_device_number_type arg)
  {
    msg_.device_number = std::move(arg);
    return Init_Feedback_device_name(msg_);
  }

private:
  ::puma_motor_msgs::msg::Feedback msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::puma_motor_msgs::msg::Feedback>()
{
  return puma_motor_msgs::msg::builder::Init_Feedback_device_number();
}

}  // namespace puma_motor_msgs

#endif  // PUMA_MOTOR_MSGS__MSG__DETAIL__FEEDBACK__BUILDER_HPP_
