// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from puma_motor_msgs:msg/Feedback.idl
// generated code does not contain a copyright notice

#ifndef PUMA_MOTOR_MSGS__MSG__DETAIL__FEEDBACK__STRUCT_HPP_
#define PUMA_MOTOR_MSGS__MSG__DETAIL__FEEDBACK__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__puma_motor_msgs__msg__Feedback __attribute__((deprecated))
#else
# define DEPRECATED__puma_motor_msgs__msg__Feedback __declspec(deprecated)
#endif

namespace puma_motor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Feedback_
{
  using Type = Feedback_<ContainerAllocator>;

  explicit Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->device_number = 0;
      this->device_name = "";
      this->duty_cycle = 0.0f;
      this->current = 0.0f;
      this->travel = 0.0;
      this->speed = 0.0;
      this->setpoint = 0.0;
    }
  }

  explicit Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : device_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->device_number = 0;
      this->device_name = "";
      this->duty_cycle = 0.0f;
      this->current = 0.0f;
      this->travel = 0.0;
      this->speed = 0.0;
      this->setpoint = 0.0;
    }
  }

  // field types and members
  using _device_number_type =
    uint8_t;
  _device_number_type device_number;
  using _device_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _device_name_type device_name;
  using _duty_cycle_type =
    float;
  _duty_cycle_type duty_cycle;
  using _current_type =
    float;
  _current_type current;
  using _travel_type =
    double;
  _travel_type travel;
  using _speed_type =
    double;
  _speed_type speed;
  using _setpoint_type =
    double;
  _setpoint_type setpoint;

  // setters for named parameter idiom
  Type & set__device_number(
    const uint8_t & _arg)
  {
    this->device_number = _arg;
    return *this;
  }
  Type & set__device_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->device_name = _arg;
    return *this;
  }
  Type & set__duty_cycle(
    const float & _arg)
  {
    this->duty_cycle = _arg;
    return *this;
  }
  Type & set__current(
    const float & _arg)
  {
    this->current = _arg;
    return *this;
  }
  Type & set__travel(
    const double & _arg)
  {
    this->travel = _arg;
    return *this;
  }
  Type & set__speed(
    const double & _arg)
  {
    this->speed = _arg;
    return *this;
  }
  Type & set__setpoint(
    const double & _arg)
  {
    this->setpoint = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    puma_motor_msgs::msg::Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const puma_motor_msgs::msg::Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<puma_motor_msgs::msg::Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<puma_motor_msgs::msg::Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      puma_motor_msgs::msg::Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<puma_motor_msgs::msg::Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      puma_motor_msgs::msg::Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<puma_motor_msgs::msg::Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<puma_motor_msgs::msg::Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<puma_motor_msgs::msg::Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__puma_motor_msgs__msg__Feedback
    std::shared_ptr<puma_motor_msgs::msg::Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__puma_motor_msgs__msg__Feedback
    std::shared_ptr<puma_motor_msgs::msg::Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Feedback_ & other) const
  {
    if (this->device_number != other.device_number) {
      return false;
    }
    if (this->device_name != other.device_name) {
      return false;
    }
    if (this->duty_cycle != other.duty_cycle) {
      return false;
    }
    if (this->current != other.current) {
      return false;
    }
    if (this->travel != other.travel) {
      return false;
    }
    if (this->speed != other.speed) {
      return false;
    }
    if (this->setpoint != other.setpoint) {
      return false;
    }
    return true;
  }
  bool operator!=(const Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Feedback_

// alias to use template instance with default allocator
using Feedback =
  puma_motor_msgs::msg::Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace puma_motor_msgs

#endif  // PUMA_MOTOR_MSGS__MSG__DETAIL__FEEDBACK__STRUCT_HPP_
