// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from puma_motor_msgs:msg/MultiFeedback.idl
// generated code does not contain a copyright notice

#ifndef PUMA_MOTOR_MSGS__MSG__DETAIL__MULTI_FEEDBACK__TRAITS_HPP_
#define PUMA_MOTOR_MSGS__MSG__DETAIL__MULTI_FEEDBACK__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "puma_motor_msgs/msg/detail/multi_feedback__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'drivers_feedback'
#include "puma_motor_msgs/msg/detail/feedback__traits.hpp"

namespace puma_motor_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MultiFeedback & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: drivers_feedback
  {
    if (msg.drivers_feedback.size() == 0) {
      out << "drivers_feedback: []";
    } else {
      out << "drivers_feedback: [";
      size_t pending_items = msg.drivers_feedback.size();
      for (auto item : msg.drivers_feedback) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MultiFeedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: drivers_feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.drivers_feedback.size() == 0) {
      out << "drivers_feedback: []\n";
    } else {
      out << "drivers_feedback:\n";
      for (auto item : msg.drivers_feedback) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MultiFeedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace puma_motor_msgs

namespace rosidl_generator_traits
{

[[deprecated("use puma_motor_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const puma_motor_msgs::msg::MultiFeedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  puma_motor_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use puma_motor_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const puma_motor_msgs::msg::MultiFeedback & msg)
{
  return puma_motor_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<puma_motor_msgs::msg::MultiFeedback>()
{
  return "puma_motor_msgs::msg::MultiFeedback";
}

template<>
inline const char * name<puma_motor_msgs::msg::MultiFeedback>()
{
  return "puma_motor_msgs/msg/MultiFeedback";
}

template<>
struct has_fixed_size<puma_motor_msgs::msg::MultiFeedback>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<puma_motor_msgs::msg::MultiFeedback>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<puma_motor_msgs::msg::MultiFeedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PUMA_MOTOR_MSGS__MSG__DETAIL__MULTI_FEEDBACK__TRAITS_HPP_
