// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from puma_motor_msgs:msg/MultiStatus.idl
// generated code does not contain a copyright notice

#ifndef PUMA_MOTOR_MSGS__MSG__DETAIL__MULTI_STATUS__FUNCTIONS_H_
#define PUMA_MOTOR_MSGS__MSG__DETAIL__MULTI_STATUS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "puma_motor_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "puma_motor_msgs/msg/detail/multi_status__struct.h"

/// Initialize msg/MultiStatus message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * puma_motor_msgs__msg__MultiStatus
 * )) before or use
 * puma_motor_msgs__msg__MultiStatus__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_puma_motor_msgs
bool
puma_motor_msgs__msg__MultiStatus__init(puma_motor_msgs__msg__MultiStatus * msg);

/// Finalize msg/MultiStatus message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_puma_motor_msgs
void
puma_motor_msgs__msg__MultiStatus__fini(puma_motor_msgs__msg__MultiStatus * msg);

/// Create msg/MultiStatus message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * puma_motor_msgs__msg__MultiStatus__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_puma_motor_msgs
puma_motor_msgs__msg__MultiStatus *
puma_motor_msgs__msg__MultiStatus__create();

/// Destroy msg/MultiStatus message.
/**
 * It calls
 * puma_motor_msgs__msg__MultiStatus__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_puma_motor_msgs
void
puma_motor_msgs__msg__MultiStatus__destroy(puma_motor_msgs__msg__MultiStatus * msg);

/// Check for msg/MultiStatus message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_puma_motor_msgs
bool
puma_motor_msgs__msg__MultiStatus__are_equal(const puma_motor_msgs__msg__MultiStatus * lhs, const puma_motor_msgs__msg__MultiStatus * rhs);

/// Copy a msg/MultiStatus message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_puma_motor_msgs
bool
puma_motor_msgs__msg__MultiStatus__copy(
  const puma_motor_msgs__msg__MultiStatus * input,
  puma_motor_msgs__msg__MultiStatus * output);

/// Initialize array of msg/MultiStatus messages.
/**
 * It allocates the memory for the number of elements and calls
 * puma_motor_msgs__msg__MultiStatus__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_puma_motor_msgs
bool
puma_motor_msgs__msg__MultiStatus__Sequence__init(puma_motor_msgs__msg__MultiStatus__Sequence * array, size_t size);

/// Finalize array of msg/MultiStatus messages.
/**
 * It calls
 * puma_motor_msgs__msg__MultiStatus__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_puma_motor_msgs
void
puma_motor_msgs__msg__MultiStatus__Sequence__fini(puma_motor_msgs__msg__MultiStatus__Sequence * array);

/// Create array of msg/MultiStatus messages.
/**
 * It allocates the memory for the array and calls
 * puma_motor_msgs__msg__MultiStatus__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_puma_motor_msgs
puma_motor_msgs__msg__MultiStatus__Sequence *
puma_motor_msgs__msg__MultiStatus__Sequence__create(size_t size);

/// Destroy array of msg/MultiStatus messages.
/**
 * It calls
 * puma_motor_msgs__msg__MultiStatus__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_puma_motor_msgs
void
puma_motor_msgs__msg__MultiStatus__Sequence__destroy(puma_motor_msgs__msg__MultiStatus__Sequence * array);

/// Check for msg/MultiStatus message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_puma_motor_msgs
bool
puma_motor_msgs__msg__MultiStatus__Sequence__are_equal(const puma_motor_msgs__msg__MultiStatus__Sequence * lhs, const puma_motor_msgs__msg__MultiStatus__Sequence * rhs);

/// Copy an array of msg/MultiStatus messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_puma_motor_msgs
bool
puma_motor_msgs__msg__MultiStatus__Sequence__copy(
  const puma_motor_msgs__msg__MultiStatus__Sequence * input,
  puma_motor_msgs__msg__MultiStatus__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // PUMA_MOTOR_MSGS__MSG__DETAIL__MULTI_STATUS__FUNCTIONS_H_
