// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from puma_motor_msgs:msg/MultiStatus.idl
// generated code does not contain a copyright notice

#ifndef PUMA_MOTOR_MSGS__MSG__DETAIL__MULTI_STATUS__STRUCT_HPP_
#define PUMA_MOTOR_MSGS__MSG__DETAIL__MULTI_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'drivers'
#include "puma_motor_msgs/msg/detail/status__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__puma_motor_msgs__msg__MultiStatus __attribute__((deprecated))
#else
# define DEPRECATED__puma_motor_msgs__msg__MultiStatus __declspec(deprecated)
#endif

namespace puma_motor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MultiStatus_
{
  using Type = MultiStatus_<ContainerAllocator>;

  explicit MultiStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit MultiStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _drivers_type =
    std::vector<puma_motor_msgs::msg::Status_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<puma_motor_msgs::msg::Status_<ContainerAllocator>>>;
  _drivers_type drivers;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__drivers(
    const std::vector<puma_motor_msgs::msg::Status_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<puma_motor_msgs::msg::Status_<ContainerAllocator>>> & _arg)
  {
    this->drivers = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    puma_motor_msgs::msg::MultiStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const puma_motor_msgs::msg::MultiStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<puma_motor_msgs::msg::MultiStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<puma_motor_msgs::msg::MultiStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      puma_motor_msgs::msg::MultiStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<puma_motor_msgs::msg::MultiStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      puma_motor_msgs::msg::MultiStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<puma_motor_msgs::msg::MultiStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<puma_motor_msgs::msg::MultiStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<puma_motor_msgs::msg::MultiStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__puma_motor_msgs__msg__MultiStatus
    std::shared_ptr<puma_motor_msgs::msg::MultiStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__puma_motor_msgs__msg__MultiStatus
    std::shared_ptr<puma_motor_msgs::msg::MultiStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MultiStatus_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->drivers != other.drivers) {
      return false;
    }
    return true;
  }
  bool operator!=(const MultiStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MultiStatus_

// alias to use template instance with default allocator
using MultiStatus =
  puma_motor_msgs::msg::MultiStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace puma_motor_msgs

#endif  // PUMA_MOTOR_MSGS__MSG__DETAIL__MULTI_STATUS__STRUCT_HPP_
