// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from puma_motor_msgs:msg/Status.idl
// generated code does not contain a copyright notice
#include "puma_motor_msgs/msg/detail/status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `device_name`
#include "rosidl_runtime_c/string_functions.h"

bool
puma_motor_msgs__msg__Status__init(puma_motor_msgs__msg__Status * msg)
{
  if (!msg) {
    return false;
  }
  // device_number
  // device_name
  if (!rosidl_runtime_c__String__init(&msg->device_name)) {
    puma_motor_msgs__msg__Status__fini(msg);
    return false;
  }
  // bus_voltage
  // temperature
  // output_voltage
  // analog_input
  // mode
  // fault
  return true;
}

void
puma_motor_msgs__msg__Status__fini(puma_motor_msgs__msg__Status * msg)
{
  if (!msg) {
    return;
  }
  // device_number
  // device_name
  rosidl_runtime_c__String__fini(&msg->device_name);
  // bus_voltage
  // temperature
  // output_voltage
  // analog_input
  // mode
  // fault
}

bool
puma_motor_msgs__msg__Status__are_equal(const puma_motor_msgs__msg__Status * lhs, const puma_motor_msgs__msg__Status * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // device_number
  if (lhs->device_number != rhs->device_number) {
    return false;
  }
  // device_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->device_name), &(rhs->device_name)))
  {
    return false;
  }
  // bus_voltage
  if (lhs->bus_voltage != rhs->bus_voltage) {
    return false;
  }
  // temperature
  if (lhs->temperature != rhs->temperature) {
    return false;
  }
  // output_voltage
  if (lhs->output_voltage != rhs->output_voltage) {
    return false;
  }
  // analog_input
  if (lhs->analog_input != rhs->analog_input) {
    return false;
  }
  // mode
  if (lhs->mode != rhs->mode) {
    return false;
  }
  // fault
  if (lhs->fault != rhs->fault) {
    return false;
  }
  return true;
}

bool
puma_motor_msgs__msg__Status__copy(
  const puma_motor_msgs__msg__Status * input,
  puma_motor_msgs__msg__Status * output)
{
  if (!input || !output) {
    return false;
  }
  // device_number
  output->device_number = input->device_number;
  // device_name
  if (!rosidl_runtime_c__String__copy(
      &(input->device_name), &(output->device_name)))
  {
    return false;
  }
  // bus_voltage
  output->bus_voltage = input->bus_voltage;
  // temperature
  output->temperature = input->temperature;
  // output_voltage
  output->output_voltage = input->output_voltage;
  // analog_input
  output->analog_input = input->analog_input;
  // mode
  output->mode = input->mode;
  // fault
  output->fault = input->fault;
  return true;
}

puma_motor_msgs__msg__Status *
puma_motor_msgs__msg__Status__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  puma_motor_msgs__msg__Status * msg = (puma_motor_msgs__msg__Status *)allocator.allocate(sizeof(puma_motor_msgs__msg__Status), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(puma_motor_msgs__msg__Status));
  bool success = puma_motor_msgs__msg__Status__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
puma_motor_msgs__msg__Status__destroy(puma_motor_msgs__msg__Status * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    puma_motor_msgs__msg__Status__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
puma_motor_msgs__msg__Status__Sequence__init(puma_motor_msgs__msg__Status__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  puma_motor_msgs__msg__Status * data = NULL;

  if (size) {
    data = (puma_motor_msgs__msg__Status *)allocator.zero_allocate(size, sizeof(puma_motor_msgs__msg__Status), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = puma_motor_msgs__msg__Status__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        puma_motor_msgs__msg__Status__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
puma_motor_msgs__msg__Status__Sequence__fini(puma_motor_msgs__msg__Status__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      puma_motor_msgs__msg__Status__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

puma_motor_msgs__msg__Status__Sequence *
puma_motor_msgs__msg__Status__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  puma_motor_msgs__msg__Status__Sequence * array = (puma_motor_msgs__msg__Status__Sequence *)allocator.allocate(sizeof(puma_motor_msgs__msg__Status__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = puma_motor_msgs__msg__Status__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
puma_motor_msgs__msg__Status__Sequence__destroy(puma_motor_msgs__msg__Status__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    puma_motor_msgs__msg__Status__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
puma_motor_msgs__msg__Status__Sequence__are_equal(const puma_motor_msgs__msg__Status__Sequence * lhs, const puma_motor_msgs__msg__Status__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!puma_motor_msgs__msg__Status__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
puma_motor_msgs__msg__Status__Sequence__copy(
  const puma_motor_msgs__msg__Status__Sequence * input,
  puma_motor_msgs__msg__Status__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(puma_motor_msgs__msg__Status);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    puma_motor_msgs__msg__Status * data =
      (puma_motor_msgs__msg__Status *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!puma_motor_msgs__msg__Status__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          puma_motor_msgs__msg__Status__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!puma_motor_msgs__msg__Status__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
