// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from puma_motor_msgs:msg/Feedback.idl
// generated code does not contain a copyright notice

#ifndef PUMA_MOTOR_MSGS__MSG__DETAIL__FEEDBACK__STRUCT_H_
#define PUMA_MOTOR_MSGS__MSG__DETAIL__FEEDBACK__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'device_name'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/Feedback in the package puma_motor_msgs.
/**
  * Number on the bus (CAN ID).
 */
typedef struct puma_motor_msgs__msg__Feedback
{
  uint8_t device_number;
  /// Name of joint controlled, or other identifier.
  rosidl_runtime_c__String device_name;
  /// Duty cycle of the h-bridge driver (-1..1).
  float duty_cycle;
  /// Current consumed (amps).
  float current;
  /// Travel as measured by the encoder (rad).
  double travel;
  /// Angular velocity as measured by the encoder (rad/s).
  double speed;
  /// The reported setpoint value of the on-board controller for the given mode.
  /// In voltage control, duty cycle of the h-bridge driver (-1..1).
  /// In speed control, angular velocity setpoint of the on-board controller (rad/s).
  /// In position control, travel as measured by the encoder (rad).
  /// In current control, the current consumed (amps).
  double setpoint;
} puma_motor_msgs__msg__Feedback;

// Struct for a sequence of puma_motor_msgs__msg__Feedback.
typedef struct puma_motor_msgs__msg__Feedback__Sequence
{
  puma_motor_msgs__msg__Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} puma_motor_msgs__msg__Feedback__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PUMA_MOTOR_MSGS__MSG__DETAIL__FEEDBACK__STRUCT_H_
