// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from puma_motor_msgs:msg/MultiStatus.idl
// generated code does not contain a copyright notice
#include "puma_motor_msgs/msg/detail/multi_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `drivers`
#include "puma_motor_msgs/msg/detail/status__functions.h"

bool
puma_motor_msgs__msg__MultiStatus__init(puma_motor_msgs__msg__MultiStatus * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    puma_motor_msgs__msg__MultiStatus__fini(msg);
    return false;
  }
  // drivers
  if (!puma_motor_msgs__msg__Status__Sequence__init(&msg->drivers, 0)) {
    puma_motor_msgs__msg__MultiStatus__fini(msg);
    return false;
  }
  return true;
}

void
puma_motor_msgs__msg__MultiStatus__fini(puma_motor_msgs__msg__MultiStatus * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // drivers
  puma_motor_msgs__msg__Status__Sequence__fini(&msg->drivers);
}

bool
puma_motor_msgs__msg__MultiStatus__are_equal(const puma_motor_msgs__msg__MultiStatus * lhs, const puma_motor_msgs__msg__MultiStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // drivers
  if (!puma_motor_msgs__msg__Status__Sequence__are_equal(
      &(lhs->drivers), &(rhs->drivers)))
  {
    return false;
  }
  return true;
}

bool
puma_motor_msgs__msg__MultiStatus__copy(
  const puma_motor_msgs__msg__MultiStatus * input,
  puma_motor_msgs__msg__MultiStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // drivers
  if (!puma_motor_msgs__msg__Status__Sequence__copy(
      &(input->drivers), &(output->drivers)))
  {
    return false;
  }
  return true;
}

puma_motor_msgs__msg__MultiStatus *
puma_motor_msgs__msg__MultiStatus__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  puma_motor_msgs__msg__MultiStatus * msg = (puma_motor_msgs__msg__MultiStatus *)allocator.allocate(sizeof(puma_motor_msgs__msg__MultiStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(puma_motor_msgs__msg__MultiStatus));
  bool success = puma_motor_msgs__msg__MultiStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
puma_motor_msgs__msg__MultiStatus__destroy(puma_motor_msgs__msg__MultiStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    puma_motor_msgs__msg__MultiStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
puma_motor_msgs__msg__MultiStatus__Sequence__init(puma_motor_msgs__msg__MultiStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  puma_motor_msgs__msg__MultiStatus * data = NULL;

  if (size) {
    data = (puma_motor_msgs__msg__MultiStatus *)allocator.zero_allocate(size, sizeof(puma_motor_msgs__msg__MultiStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = puma_motor_msgs__msg__MultiStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        puma_motor_msgs__msg__MultiStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
puma_motor_msgs__msg__MultiStatus__Sequence__fini(puma_motor_msgs__msg__MultiStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      puma_motor_msgs__msg__MultiStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

puma_motor_msgs__msg__MultiStatus__Sequence *
puma_motor_msgs__msg__MultiStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  puma_motor_msgs__msg__MultiStatus__Sequence * array = (puma_motor_msgs__msg__MultiStatus__Sequence *)allocator.allocate(sizeof(puma_motor_msgs__msg__MultiStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = puma_motor_msgs__msg__MultiStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
puma_motor_msgs__msg__MultiStatus__Sequence__destroy(puma_motor_msgs__msg__MultiStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    puma_motor_msgs__msg__MultiStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
puma_motor_msgs__msg__MultiStatus__Sequence__are_equal(const puma_motor_msgs__msg__MultiStatus__Sequence * lhs, const puma_motor_msgs__msg__MultiStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!puma_motor_msgs__msg__MultiStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
puma_motor_msgs__msg__MultiStatus__Sequence__copy(
  const puma_motor_msgs__msg__MultiStatus__Sequence * input,
  puma_motor_msgs__msg__MultiStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(puma_motor_msgs__msg__MultiStatus);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    puma_motor_msgs__msg__MultiStatus * data =
      (puma_motor_msgs__msg__MultiStatus *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!puma_motor_msgs__msg__MultiStatus__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          puma_motor_msgs__msg__MultiStatus__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!puma_motor_msgs__msg__MultiStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
