// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from puma_motor_msgs:msg/MultiStatus.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "puma_motor_msgs/msg/detail/multi_status__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace puma_motor_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void MultiStatus_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) puma_motor_msgs::msg::MultiStatus(_init);
}

void MultiStatus_fini_function(void * message_memory)
{
  auto typed_message = static_cast<puma_motor_msgs::msg::MultiStatus *>(message_memory);
  typed_message->~MultiStatus();
}

size_t size_function__MultiStatus__drivers(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<puma_motor_msgs::msg::Status> *>(untyped_member);
  return member->size();
}

const void * get_const_function__MultiStatus__drivers(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<puma_motor_msgs::msg::Status> *>(untyped_member);
  return &member[index];
}

void * get_function__MultiStatus__drivers(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<puma_motor_msgs::msg::Status> *>(untyped_member);
  return &member[index];
}

void fetch_function__MultiStatus__drivers(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const puma_motor_msgs::msg::Status *>(
    get_const_function__MultiStatus__drivers(untyped_member, index));
  auto & value = *reinterpret_cast<puma_motor_msgs::msg::Status *>(untyped_value);
  value = item;
}

void assign_function__MultiStatus__drivers(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<puma_motor_msgs::msg::Status *>(
    get_function__MultiStatus__drivers(untyped_member, index));
  const auto & value = *reinterpret_cast<const puma_motor_msgs::msg::Status *>(untyped_value);
  item = value;
}

void resize_function__MultiStatus__drivers(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<puma_motor_msgs::msg::Status> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember MultiStatus_message_member_array[2] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(puma_motor_msgs::msg::MultiStatus, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "drivers",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<puma_motor_msgs::msg::Status>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(puma_motor_msgs::msg::MultiStatus, drivers),  // bytes offset in struct
    nullptr,  // default value
    size_function__MultiStatus__drivers,  // size() function pointer
    get_const_function__MultiStatus__drivers,  // get_const(index) function pointer
    get_function__MultiStatus__drivers,  // get(index) function pointer
    fetch_function__MultiStatus__drivers,  // fetch(index, &value) function pointer
    assign_function__MultiStatus__drivers,  // assign(index, value) function pointer
    resize_function__MultiStatus__drivers  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers MultiStatus_message_members = {
  "puma_motor_msgs::msg",  // message namespace
  "MultiStatus",  // message name
  2,  // number of fields
  sizeof(puma_motor_msgs::msg::MultiStatus),
  MultiStatus_message_member_array,  // message members
  MultiStatus_init_function,  // function to initialize message memory (memory has to be allocated)
  MultiStatus_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t MultiStatus_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &MultiStatus_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace puma_motor_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<puma_motor_msgs::msg::MultiStatus>()
{
  return &::puma_motor_msgs::msg::rosidl_typesupport_introspection_cpp::MultiStatus_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, puma_motor_msgs, msg, MultiStatus)() {
  return &::puma_motor_msgs::msg::rosidl_typesupport_introspection_cpp::MultiStatus_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
