// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from puma_motor_msgs:msg/Status.idl
// generated code does not contain a copyright notice

#ifndef PUMA_MOTOR_MSGS__MSG__DETAIL__STATUS__BUILDER_HPP_
#define PUMA_MOTOR_MSGS__MSG__DETAIL__STATUS__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "puma_motor_msgs/msg/detail/status__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace puma_motor_msgs
{

namespace msg
{

namespace builder
{

class Init_Status_fault
{
public:
  explicit Init_Status_fault(::puma_motor_msgs::msg::Status & msg)
  : msg_(msg)
  {}
  ::puma_motor_msgs::msg::Status fault(::puma_motor_msgs::msg::Status::_fault_type arg)
  {
    msg_.fault = std::move(arg);
    return std::move(msg_);
  }

private:
  ::puma_motor_msgs::msg::Status msg_;
};

class Init_Status_mode
{
public:
  explicit Init_Status_mode(::puma_motor_msgs::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_fault mode(::puma_motor_msgs::msg::Status::_mode_type arg)
  {
    msg_.mode = std::move(arg);
    return Init_Status_fault(msg_);
  }

private:
  ::puma_motor_msgs::msg::Status msg_;
};

class Init_Status_analog_input
{
public:
  explicit Init_Status_analog_input(::puma_motor_msgs::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_mode analog_input(::puma_motor_msgs::msg::Status::_analog_input_type arg)
  {
    msg_.analog_input = std::move(arg);
    return Init_Status_mode(msg_);
  }

private:
  ::puma_motor_msgs::msg::Status msg_;
};

class Init_Status_output_voltage
{
public:
  explicit Init_Status_output_voltage(::puma_motor_msgs::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_analog_input output_voltage(::puma_motor_msgs::msg::Status::_output_voltage_type arg)
  {
    msg_.output_voltage = std::move(arg);
    return Init_Status_analog_input(msg_);
  }

private:
  ::puma_motor_msgs::msg::Status msg_;
};

class Init_Status_temperature
{
public:
  explicit Init_Status_temperature(::puma_motor_msgs::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_output_voltage temperature(::puma_motor_msgs::msg::Status::_temperature_type arg)
  {
    msg_.temperature = std::move(arg);
    return Init_Status_output_voltage(msg_);
  }

private:
  ::puma_motor_msgs::msg::Status msg_;
};

class Init_Status_bus_voltage
{
public:
  explicit Init_Status_bus_voltage(::puma_motor_msgs::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_temperature bus_voltage(::puma_motor_msgs::msg::Status::_bus_voltage_type arg)
  {
    msg_.bus_voltage = std::move(arg);
    return Init_Status_temperature(msg_);
  }

private:
  ::puma_motor_msgs::msg::Status msg_;
};

class Init_Status_device_name
{
public:
  explicit Init_Status_device_name(::puma_motor_msgs::msg::Status & msg)
  : msg_(msg)
  {}
  Init_Status_bus_voltage device_name(::puma_motor_msgs::msg::Status::_device_name_type arg)
  {
    msg_.device_name = std::move(arg);
    return Init_Status_bus_voltage(msg_);
  }

private:
  ::puma_motor_msgs::msg::Status msg_;
};

class Init_Status_device_number
{
public:
  Init_Status_device_number()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Status_device_name device_number(::puma_motor_msgs::msg::Status::_device_number_type arg)
  {
    msg_.device_number = std::move(arg);
    return Init_Status_device_name(msg_);
  }

private:
  ::puma_motor_msgs::msg::Status msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::puma_motor_msgs::msg::Status>()
{
  return puma_motor_msgs::msg::builder::Init_Status_device_number();
}

}  // namespace puma_motor_msgs

#endif  // PUMA_MOTOR_MSGS__MSG__DETAIL__STATUS__BUILDER_HPP_
