// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from puma_motor_msgs:msg/Status.idl
// generated code does not contain a copyright notice

#ifndef PUMA_MOTOR_MSGS__MSG__DETAIL__STATUS__TRAITS_HPP_
#define PUMA_MOTOR_MSGS__MSG__DETAIL__STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "puma_motor_msgs/msg/detail/status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace puma_motor_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Status & msg,
  std::ostream & out)
{
  out << "{";
  // member: device_number
  {
    out << "device_number: ";
    rosidl_generator_traits::value_to_yaml(msg.device_number, out);
    out << ", ";
  }

  // member: device_name
  {
    out << "device_name: ";
    rosidl_generator_traits::value_to_yaml(msg.device_name, out);
    out << ", ";
  }

  // member: bus_voltage
  {
    out << "bus_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.bus_voltage, out);
    out << ", ";
  }

  // member: temperature
  {
    out << "temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature, out);
    out << ", ";
  }

  // member: output_voltage
  {
    out << "output_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.output_voltage, out);
    out << ", ";
  }

  // member: analog_input
  {
    out << "analog_input: ";
    rosidl_generator_traits::value_to_yaml(msg.analog_input, out);
    out << ", ";
  }

  // member: mode
  {
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
    out << ", ";
  }

  // member: fault
  {
    out << "fault: ";
    rosidl_generator_traits::value_to_yaml(msg.fault, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Status & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: device_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "device_number: ";
    rosidl_generator_traits::value_to_yaml(msg.device_number, out);
    out << "\n";
  }

  // member: device_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "device_name: ";
    rosidl_generator_traits::value_to_yaml(msg.device_name, out);
    out << "\n";
  }

  // member: bus_voltage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "bus_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.bus_voltage, out);
    out << "\n";
  }

  // member: temperature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature, out);
    out << "\n";
  }

  // member: output_voltage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "output_voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.output_voltage, out);
    out << "\n";
  }

  // member: analog_input
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "analog_input: ";
    rosidl_generator_traits::value_to_yaml(msg.analog_input, out);
    out << "\n";
  }

  // member: mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
    out << "\n";
  }

  // member: fault
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fault: ";
    rosidl_generator_traits::value_to_yaml(msg.fault, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Status & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace puma_motor_msgs

namespace rosidl_generator_traits
{

[[deprecated("use puma_motor_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const puma_motor_msgs::msg::Status & msg,
  std::ostream & out, size_t indentation = 0)
{
  puma_motor_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use puma_motor_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const puma_motor_msgs::msg::Status & msg)
{
  return puma_motor_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<puma_motor_msgs::msg::Status>()
{
  return "puma_motor_msgs::msg::Status";
}

template<>
inline const char * name<puma_motor_msgs::msg::Status>()
{
  return "puma_motor_msgs/msg/Status";
}

template<>
struct has_fixed_size<puma_motor_msgs::msg::Status>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<puma_motor_msgs::msg::Status>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<puma_motor_msgs::msg::Status>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PUMA_MOTOR_MSGS__MSG__DETAIL__STATUS__TRAITS_HPP_
